
/* -------------------------------------------------------------------------
   A. Veneziani - Programma elementare per il disegno
                  utilizzante il componente TImage e altri componenti VCL
                  (Attenzione !! - Importante !!
                  Il componente TImage ha la propriet Stretch a true
                  per evitare effetti di flickering)

                  Scritto in Borland C++ Builder 6
   ------------------------------------------------------------------------- */                


//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "disegna.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;
TPoint Pi, Pf;
bool inizio = true;
int xprec, yprec;

// routine che riempie tutta la Image1 di uno
// sfondo nero, cancellando tutti i contenti disegnati
void pulisci()
{
    TRect *R;

   // imposta colore nero come colore di riempimento (brush) 
   Form1->Image1->Canvas->Brush->Color = clBlack;

   // crea un oggetto rettangolo R delle dimensioni di Image1
   R = new TRect(1,1,Form1->Image1->Width,Form1->Image1->Height);
   // effettua il riempimento di R con il colore di fondo (brush)
   // cancellando ogni disegno
   Form1->Image1->Canvas->FillRect(*R);
}

//  costruttore di Form1 - eseguito al momento dell'istanza di Form1
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
     // riempie tutta di nero la Image1
     pulisci();
     // imposta il colore iniziale della penna (di disegno) a bianco
     Image1->Canvas->Pen->Color = clWhite;

     // imposta tutte le operazioni di disegno in foreground
     // con logica dei bit a XOR
     Image1->Canvas->Pen->Mode = pmXor;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
      // al primo click dell'elemento grafico (punto iniziale)....
      if (inizio)
      {
          Pi.x = X;
          Pi.y = Y;
          // muove il punto di disegno a x y
          Image1->Canvas->MoveTo(X,Y);
          // registra la posizione attuale in apposite variabili
          xprec = X;
          yprec = Y;
          // indica che e' gia' in corso una operazione di disegno
          // di una forma grafica (cerchio, rettangolo, linea)
          inizio = false;
      }
      else
         inizio = true;   // segnala che una operazione di disegno si  conclusa

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    // se ormai l'operazione di tracciamento di una forma
    // ha avuto inizio...
    if (! inizio)
    {
         // sovratraccia la figura precedentemente disegnata
         // [ se colore selezionato bianco - disegna bianco su bianco = nero  (1 xor 1 = 0)
         // e bianco su nero = bianco (1 xor 0 = 1) (usualmente intersezioni) ]
         if (cmbForma->ItemIndex == 0)
         {
             // si sposta sulla posizione iniziale
             Image1->Canvas->MoveTo(Pi.x,Pi.y);
             // traccia la linea fino alla posizione finale
             Image1->Canvas->LineTo(xprec,yprec);
         }
         if (cmbForma->ItemIndex == 1)    Image1->Canvas->Ellipse(Pi.x,Pi.y,xprec,yprec);
         if (cmbForma->ItemIndex == 2)    Image1->Canvas->Rectangle(Pi.x,Pi.y,xprec,yprec);

         // traccia di nuovo (sempre modalita' XOR) la figura nel suo colore
         if (cmbForma->ItemIndex == 0)
         {
             // traccia la linea fino alla posizione finale
             Image1->Canvas->MoveTo(Pi.x,Pi.y);
             // si sposta sulla posizione iniziale
             Image1->Canvas->LineTo(X,Y);
         }
         if (cmbForma->ItemIndex == 1)    Image1->Canvas->Ellipse(Pi.x,Pi.y,X,Y);
         if (cmbForma->ItemIndex == 2)    Image1->Canvas->Rectangle(Pi.x,Pi.y,X,Y);

         // memorizza posizione finale precedente
         xprec = X;
         yprec = Y;
    }
}
//---------------------------------------------------------------------------
// ogni nuova selezione regola il colore
void __fastcall TForm1::cmbColoreChange(TObject *Sender)
{
    if (cmbColore->ItemIndex == 0) Image1->Canvas->Pen->Color = clWhite;
    if (cmbColore->ItemIndex == 1) Image1->Canvas->Pen->Color = clRed;
    if (cmbColore->ItemIndex == 2) Image1->Canvas->Pen->Color = clGreen;
    if (cmbColore->ItemIndex == 3) Image1->Canvas->Pen->Color = clYellow;
    if (cmbColore->ItemIndex == 4) Image1->Canvas->Pen->Color = clBlue;
}
//---------------------------------------------------------------------------

// ogni nuova selezione regola lo spessore della linea
void __fastcall TForm1::cmbSpessoreChange(TObject *Sender)
{
    if (cmbSpessore->ItemIndex == 0)  Image1->Canvas->Pen->Width = 1;
    if (cmbSpessore->ItemIndex == 1)  Image1->Canvas->Pen->Width = 2;
    if (cmbSpessore->ItemIndex == 2)  Image1->Canvas->Pen->Width = 3;
    if (cmbSpessore->ItemIndex == 3)  Image1->Canvas->Pen->Width = 4;            
}
//---------------------------------------------------------------------------
// quando si preme l'apposito pulsante effettua
// la cancellazione del disegno
void __fastcall TForm1::btnCancellaClick(TObject *Sender)
{
     pulisci();
}
//---------------------------------------------------------------------------

// permette il salvataggio del disegno come bitmap
void __fastcall TForm1::btnSalvaClick(TObject *Sender)
{
     AnsiString PthENomeImg;

     // azzera il nome del file
     dlgSalva->FileName = "";
     // sceglie la directory iniziale partendo da
     // quella ove correntemente il programma sta' girando
     dlgSalva->InitialDir = ".\\img";
     // imposta il filtro dei file a *.bmp (files bitmap)
     dlgSalva->Filter = "Bitmap image (*.bmp)|*.bmp";
     // prevede l'aggiunta di una estensione automantica .bmp
     // se non presente nel nome del file
     dlgSalva->DefaultExt = ".bmp";

     // apre la box di dialogo per il salvataggio del file
     dlgSalva->Execute();
     // rileva - se indicato - il nome del file
     PthENomeImg = dlgSalva->FileName;

     // se  stato indicato un nome, salva una bitmap
     // corrispondente al disegno con quel nome
     if (dlgSalva->FileName != "")
        Image1->Picture->SaveToFile(PthENomeImg);
}
//---------------------------------------------------------------------------

